--Unique Id for Libraries that require a unique string. MD5 Hash of Name
local uniqueID = "f45a447deea8dc934ce5067ebe17bbe6"

--Variables to hold persisted data
local PER_GL_SETTINGS = nil
local PER_GL_CHAT_DATA = nil
local TopContainerIndex = 1
local NeedsReload = false
local timerName = uniqueID .. "_AutosaveTimer"

--Variables for addon Menu
local LAM, panelID
local LCM, namedCategories

local function btnCategoryClick(...)
	d(namedCategories)
end

local function getCCD(firstContainer, lastContainer)
	local result = {}
	
	--Itterate over containers
	for ChatContainer = firstContainer, lastContainer, 1 do
		result[ChatContainer] = {}
			--Itterate over tabs
			for Tab = 1, GetNumChatContainerTabs(ChatContainer), 1 do
			result[ChatContainer][Tab] = {}
			result[ChatContainer][Tab].name, result[ChatContainer][Tab].isLocked,
			result[ChatContainer][Tab].isInteractable, result[ChatContainer][Tab].isCombatLog, 
			result[ChatContainer][Tab].areTimestampsEnabled = GetChatContainerTabInfo(ChatContainer, Tab)
			
				--Itterate over Categories
				result[ChatContainer][Tab]["Categories"] = {}
				
				for CatID, CatName in pairs (namedCategories) do
					local isEnabeled = IsChatContainerTabCategoryEnabled(ChatContainer,Tab,CatID)
					result[ChatContainer][Tab]["Categories"][CatName] = isEnabeled
				end
			end
	end
	
	return result
end


local function setCCD(CCD)
	--Itterate over ChatContainers. Do not create or remove anymore
	local TopContainerIndex = TopContainerIndex
	
	if(TopContainerIndex > #CCD) then TopContainerIndex = #CCD end
	--d(TopContainerIndex)
	
	for ChatContainer=1, TopContainerIndex, 1 do
		--Itterate over Tabs, create and remove as nessesary
		for Tab=1, #CCD[ChatContainer], 1 do
			--Create a Tab if nessesary while applying CombatLog State
			if (GetNumChatContainerTabs(ChatContainer) < Tab) then
				NeedsReload = true
				AddChatContainerTab(ChatContainer, nil,  CCD[ChatContainer][Tab].isCombatLog) 
			end
			
			--Check if settings are different between tabs. Use Temp variables to shorten the syntax
			local TabDat = CCD[ChatContainer][Tab]
			local TabTarget = {GetChatContainerTabInfo(ChatContainer, Tab)}

			--Check if anything that requires a reload will need to be changed, then apply the settings
			if (TabDat.name ~= TabTarget[1]) or (TabDat.isLocked ~= TabTarget[2]) or (TabDat.isInteractable ~= TabTarget[3]) 
				or (TabDat.areTimestampsEnabled ~= TabTarget[5]) then
				NeedsReload = true
			end
			SetChatContainerTabInfo(ChatContainer, Tab, TabDat.name, TabDat.isLocked, 
				TabDat.isInteractable, TabDat.areTimestampsEnabled) 
			
			--Itterate over Categories and apply them
			for CatID, CatName in pairs (namedCategories) do
				if (CCD[ChatContainer][Tab]["Categories"][CatName] ~= nil) then
					local isEnabeled = CCD[ChatContainer][Tab]["Categories"][CatName]
					SetChatContainerTabCategoryEnabled(ChatContainer, Tab, CatID, isEnabeled)
				end
			end
		end
		
		--Remove unneeded Tabs from the UI
		local TabPastLimit = #CCD[ChatContainer]+1
		while (GetNumChatContainerTabs(ChatContainer) >= TabPastLimit) do
			d("Removed Containers")
			NeedsReload = true
			RemoveChatContainerTab(ChatContainer, TabPastLimit)
		end
	end
	
	
	--All Chat Container Data applied, check if Reload nessesary for what has been changed
	if NeedsReload then
		ReloadUI()
	end
end

local function getColors()
    local result = {}
	
	for CatID, CatName in pairs (namedCategories) do
		local r, g, b = GetChatCategoryColor(CatID)
		result[CatName] = { red = r, green = g, blue = b }
	end
	
	return result
end

local function setColors(Colors)
	for CatID, CatName in pairs (namedCategories) do
		if(Colors[CatName] ~= nil) then
			SetChatCategoryColor(CatID, Colors[CatName].red, Colors[CatName].green, Colors[CatName].blue) 
		end
	end
end

--GetSetter Functions
local function gsInclAddiChat(value)
	--d("gsInclAddiChat")
	if value ~= nil then
		PER_GL_SETTINGS.IncludeAdditonalChat = value
	end
	return PER_GL_SETTINGS.IncludeAdditonalChat
end

local function gsAutSavTab(value)
	--d("gsAutSavTab")
	if value ~= nil then
		PER_GL_SETTINGS.AutoSaveTabs = value
	end
	return PER_GL_SETTINGS.AutoSaveTabs
end

local function gsAutSavCol(value)
	--d("gsAutSavCol")
	if value ~= nil then
		PER_GL_SETTINGS.AutoSaveColors = value
	end
	return PER_GL_SETTINGS.AutoSaveColors
end

local function gsAutAplTab(value)
	--d("gsAutAplTab")
	if value ~= nil then
		PER_GL_SETTINGS.AutoApplyTabs = value
	end
	return PER_GL_SETTINGS.AutoApplyTabs
end

local function gsAutAplCol(value)
	--d("gsAutAplCol")
	if value ~= nil then
		PER_GL_SETTINGS.AutoApplyColors = value
	end
	return PER_GL_SETTINGS.AutoApplyColors
end

--Timer Frequency and Tick Event
local function gsTimerFrequency (value)
	-- d("gsTimerFrequency")
	-- d(value)
	if value ~= nil then
		PER_GL_SETTINGS.TimerFrequency = value
	end
	--d(PER_GL_SETTINGS.TimerFrequency)
	return PER_GL_SETTINGS.TimerFrequency
end


--Operations
local function ApplyCCD()
	d("Trying to apply Chat Data")
	if (PER_GL_CHAT_DATA.CCD ~= nil) then
		setCCD(PER_GL_CHAT_DATA.CCD)
		d("Chat Data applied")
	else
		d("No chat Data found")
	end
end

local function SaveCCD(ignore1, ignore2, supressInform)
	if not (supressInform) then d("saving CCD") end
	PER_GL_CHAT_DATA.CCD = getCCD(1, TopContainerIndex)
	--d(PER_GL_CHAT_DATA.CCD)
end

local function ApplyColors()
	d("Trying to apply Colors")
	if (PER_GL_CHAT_DATA.Colors ~= nil) then
		setColors(PER_GL_CHAT_DATA.Colors)
		d("Colors Applied")
	else
		d("No Color Data found")
	end
end

local function SaveColors(_, _, supressInform)
	if not (supressInform) then d("Saving Colors") end
	PER_GL_CHAT_DATA.Colors = getColors()
	--d(PER_GL_CHAT_DATA.Colors)
end

local function DelCCD()
	PER_GL_CHAT_DATA.CCD = nil
	d("Chat Settigns Deleted")
end

local function DelColors()
	PER_GL_CHAT_DATA.Colors = nil
	d("Color Settings Deleted")
end


local function FullSaveRun()
	--d("Timer Tick")
	if (gsAutSavTab()) then
		--d("Autosave Tab Data")
		SaveCCD(nil, nil, true)
	end
	if (gsAutSavCol()) then
		--d("Autosave Tab Data")
		SaveColors(nil, nil, true)
	end
end

local function AutosaveTimerTick()
	--d("AutosaveTimerTick")
	FullSaveRun()
	ld_timer.add(timerName, gsTimerFrequency(), AutosaveTimerTick, 1)
end

local function CreateMenu()
	--Get the LAM reference
	local LAM = LibStub:GetLibrary("LibAddonMenu-1.0-to-2.0", false)

	--Create the panel, store the ID, add header, create sub menu entries
	local panelID = LAM:CreateControlPanel(uniqueID .. "Menu", "Unified Chat Tabs")
	LAM:AddHeader(panelID, uniqueID .. "_Header", "General Settings")

	--Experimental Additional Chatcontainer inclusion
	LAM:AddCheckbox(panelID, uniqueID .. "_cbAdditional", "Include extra Chatcontainers", "Off (default): Addon will only cosnider the main chat container (1), not additional ones created by other addons. On: Addon will try to store and apply tab data for addition Chat Containers, but will not create or remove any", gsInclAddiChat, gsInclAddiChat,
                 true, "Entirely experimental. No guarantee that it will not caused problems with other chat addons wich would force to reset thier data")
	
	--Put in Save related elements
	LAM:AddSlider(panelID, uniqueID .. "_slTimerFrequency", "Autosave interval", "Time in ms how often the Addon should autosave.",
		500, 5000, 100, gsTimerFrequency, gsTimerFrequency, nil, nil)
	LAM:AddCheckbox(panelID, uniqueID .. "_cbAutoSaveCCD", "Autosave Chat Data", "Automatically saves the Chat Data when the timer Ticks",
		gsAutSavTab, gsAutSavTab, nil, nil)
	LAM:AddButton(panelID, uniqueID .. "_btnSaveCCD", "Save Tab Settings", "Manually Saves the Chat Data", SaveCCD, nil, nil)
	LAM:AddButton(panelID, uniqueID .. "_btnDelCCD", "Delete Tab Data", "Delets Stored Tab Data; mind Autosave setting", DelCCD, nil, nil)
	LAM:AddCheckbox (panelID, uniqueID .. "_cbAutoSaveColors", "Autosave Colors", "Automatically saves Colors when the timer Ticks",
		gsAutSavCol, gsAutSavCol, nil, nil)
	LAM:AddButton(panelID, uniqueID .. "_btnSaveColors", "Save Colors", "Manually Saves the Category Color Settings", SaveColors, nil, nil)
	LAM:AddButton(panelID, uniqueID .. "_btnDelColors", "Delete Colors", "Deletes Color Data; Mind the Autosave setting", DelColors, nil, nil)
	
	--Put in Apply related elements
	LAM:AddCheckbox(panelID, uniqueID .. "_cbAutoApplyCCD", "Autoapply on Load", "Automatically applies saved chat data on each load of UI", gsAutAplTab, gsAutAplTab, true, "Manual Apply Rules regarding Reload of UI apply")
	LAM:AddButton(panelID, uniqueID .. "_btnApplyCCD", "Apply Chat Data", "Applies the last saved version of Chat Settings", ApplyCCD, true, "If the number or names of Tabs have changed from applying the data, /reloadui will automatically take place")
	LAM:AddCheckbox(panelID, uniqueID .. "_cbAutoApplyColors", "Apply Chat Colors on Load", "Applies Chat colors on every load of the UI", gsAutAplCol, gsAutAplCol)
	LAM:AddButton(panelID, uniqueID .. "_btnApplyColors", "Apply Colors", "Applies the last saved Char Colors", ApplyColors)
	LAM:AddButton(panelID, uniqueID .. "_btnCat", "Dump Named Categories", "Posts the list of Named Chat Categories and thier index to chat", btnCategoryClick)
end

--Addon load event
local function OnAddOnLoaded(eventCode, addOnName, ...)
    --Cancel if this is not your load event
    if (addOnName ~= "UnifiedChatTabs") then return end
	d("OnLoaded", ...)
	
	LCM = LibStub:GetLibrary("LibConstantMapper")
	namedCategories = LCM:getValIndexedKeyList(LCM:getDataByMapping("ChatCategories"))
	
	--Generate default settings, then try to load settings
	local defaultSettings = { IncludeAdditonalChat=false, AutoSaveTabs = false, AutoSaveColors = false, AutoApplyTabs = false, AutoApplyColors = false,
		TimerFrequency = 5000 }
	PER_GL_SETTINGS = ZO_SavedVars:NewAccountWide("UTC_Persistent", 4, "UCT_Settings", defaultSettings, nil)
	--Add TimerFrequency to pre 1.0 settings
	if (PER_GL_SETTINGS.TimerFrequency == nil) then
		PER_GL_SETTINGS.TimerFrequency = 5000
	end
	
	--Create your menu now
	CreateMenu()
	
	--If the user wants to include Chat Containers beyond the primary one, change the limit properly
	if PER_GL_SETTINGS.IncludeAdditonalChat == true then
		TopContainerIndex = 10
	end
	
	--Generate default CCD, then try to load saved Container from disk
	local defaultCCD = {}
	defaultCCD.CCD = nil
	defaultCCD.Colors = nil
	PER_GL_CHAT_DATA = ZO_SavedVars:NewAccountWide("UTC_Persistent", 4, "UCT_ChatContainerData", defaultCCD, nil)
	
	--Check if Autoaplication of Chat Settings or Colors on Load is wanted
	if (gsAutAplTab()) then
		ApplyCCD()
	end
	
	if(gsAutAplCol()) then
		ApplyColors()
	end
	
	--Register event for Autosave, but only after a potential Autoaply is finished
	ld_timer.add(timerName, gsTimerFrequency(), AutosaveTimerTick, 1)
	EVENT_MANAGER:RegisterForEvent(uniqueID .. "_Autosave", EVENT_CHAT_MESSAGE_CHANNEL, FullSaveRun)
end

--register OnLoaded event to load/create Settings during startup
EVENT_MANAGER:RegisterForEvent(uniqueID .. "_UCTLoaded", EVENT_ADD_ON_LOADED, OnAddOnLoaded)